Package com.evopdf

# Class HtmlToImageElement

java.lang.Object
com.evopdf.PageElement
com.evopdf.PageGraphicElement
com.evopdf.HtmlToImageElement

public class HtmlToImageElement extends PageGraphicElement
This class encapsulates a HTML to Image converter. The HTML to Image conversion is performed when the element is added to a PDF page. The resulted image is embedded in the PDF document

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `AUTO_HTML_VIEWER_HEIGHT_PX`
  The default virtual browser height in pixels is set to autodetect the HTML content height
  `static final int`
  `AUTO_PDF_HEIGHT_POINTS`
  The default width in PDF of the element is set to available width in PDF page.
  `static final int`
  `AVAILABLE_PDF_WIDTH_POINTS`
  The default width in PDF of the element is set to available width in PDF page.
  `static final int`
  `DEFAULT_HTML_VIEWER_WIDTH_PX`
  The default virtual browser width in pixels

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HtmlToImageElement(float x, float y, float width, float height, String urlToConvert)`
  Creates an URL to image converter element at the specified x and y coordinates with the specified width and height
  `HtmlToImageElement(float x, float y, float width, float height, String urlToConvert, int htmlViewerWidth, int htmlViewerHeight)`
  Creates a URL to image converter element at the specified x and y coordinates with the specified width and height using a document URL to resolve the internal links.
  `HtmlToImageElement(float x, float y, float width, float height, String htmlStringToConvert, String htmlStringBaseURL)`
  Creates a HTML string to image converter element at the specified x and y coordinates with the specified width and height using a base URL to resolve the external resources and a document URL to resolve the internal links
  `HtmlToImageElement(float x, float y, float width, float height, String htmlStringToConvert, String htmlStringBaseURL, int htmlViewerWidth, int htmlViewerHeight)`
  Creates a HTML string to image converter element at the specified x and y coordinates with the specified width and height using a base URL to resolve the external resources and a document URL to resolve the internal links.
  `HtmlToImageElement(float x, float y, float width, String urlToConvert)`
  Creates an URL to image converter element at the specified x and y coordinates with the specified width.
  `HtmlToImageElement(float x, float y, float width, String urlToConvert, int htmlViewerWidth)`
  Creates an URL to image converter element at the specified x and y coordinates with the specified width.
  `HtmlToImageElement(float x, float y, float width, String htmlStringToConvert, String htmlStringBaseURL)`
  Creates a HTML string to image converter element at the specified x and y coordinates with the specified width using a base URL to resolve the external resources and a document URL to resolve the internal links.
  `HtmlToImageElement(float x, float y, float width, String htmlStringToConvert, String htmlStringBaseURL, int htmlViewerWidth)`
  Creates a HTML string to image converter element at the specified x and y coordinates with the specified width using a base URL to resolve the external resources and a document URL to resolve the internal links.
  `HtmlToImageElement(float x, float y, String urlToConvert)`
  Creates an URL to image converter element at the specified x and y coordinates in PDF page.
  `HtmlToImageElement(float x, float y, String htmlStringToConvert, String htmlStringBaseURL)`
  Creates a HTML string to image converter element at the specified x and y coordinates in PDF page using a base URL to resolve the external resources and a document URL to resolve the internal links.
  `HtmlToImageElement(String urlToConvert)`
  Creates an URL to image converter element at the (0,0) location in PDF page.
  `HtmlToImageElement(String htmlStringToConvert, String htmlStringBaseURL)`
  Creates a HTML string to image converter element that will be rendered at the (0,0) location in PDF page using a base URL to resolve the external resources and a document URL to resolve the internal links.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AuthenticationOptions`
  `authenticationOptions()`
  This property can be set with an username and a password in order to authenticate to the web server before accessing the URL to be converted They can be used for example to resolve the IIS Integrated Windows Authentication or other types of IIS authentication
  `String[]`
  `avoidHtmlElementsBreakSelectors()`
  Gets the CSS selectors of the HTML elements to not be broken between PDF pages if possible.
  `boolean`
  `avoidImageBreak()`
  Gets the flag indicating if converter will try to avoid cutting off the images between PDF pages
  `String`
  `baseUrl()`
  Gets the base URL of the HTML string to be converted to PDF
  `float`
  `bottomSpacing()`
  Gets the space in points to introduce at the bottom of PDF pages where the HTML is rendered.
  `boolean`
  `clipHtmlView()`
  Gets a flag indicating if the HTML content is clipped by HTML viewer window width.
  `int`
  `conversionDelay()`
  Gets the additional time in seconds to wait for asynchronous items to be completely loaded or for a web page redirect to finish before starting the rendering in converter.
  `String`
  `defaultHtmlEncoding()`
  Gets the default HTML document text encoding to be used if there is no charset meta tag defined in the HTML document
  `boolean`
  `downloadAllResources()`
  Gets the flag indicating if the converter should try to download all the resources
  `boolean`
  `enable3DTransformations()`
  Gets the flag indicating if the accelerated CSS 3D transformations are enabled in converter.
  `boolean`
  `enableAccelerated2DCanvas()`
  Gets the flag indicating if the accelerated 2D canvas is enabled in converter
  `boolean`
  `enableHttp2()`
  Gets the flag indicating if the HTTP2 protocol is enabled in in HTML to Image element converter.
  `boolean`
  `enablePersistentStorage()`
  Gets the flag indicating if the persistent local storage is enabled in converter
  `boolean`
  `enableWebGL()`
  Gets the flag indicating if the WebGL is enabled in converter
  `boolean`
  `extensionsEnabled()`
  Gets the flag indicating if the HTML viewer extensions are executed during conversion.
  `boolean`
  `fitHeight()`
  Gets the fag indicating if the HTML content will be resized if necessary to fit the available height in PDF page
  `boolean`
  `fitWidth()`
  Gets the fag indicating if the HTML content will be resized if necessary to fit the available width in PDF page
  `float`
  `height()`
  Gets the height in points of the destination rectangle in PDF page where the HTML content is rendered
  `String`
  `html()`
  Gets the HTML string to be converted to PDF
  `HtmlDocumentInfo`
  `htmlDocumentInfo()`
  Gets an object populated after conversion with the title, keywords, and description of the converted HTML document
  `HtmlElementsMappingOptions`
  `htmlElementsMappingOptions()`
  Gets a reference to the object that can be used to obtain the position in PDF of the HTML elements rendered by converter.
  `int`
  `htmlViewerHeight()`
  Gets the HTML viewer height in pixels in the HTML to image converter element.
  `int`
  `htmlViewerWidth()`
  Gets the preferred HTML viewer width in pixels in HTML to image converter element
  `int`
  `htmlViewerZoom()`
  Gets the HTML viewer zoom percentage in HTML to Image element similar to zoom level in a browser
  `NameValuePairsCollection`
  `httpPostFields()`
  Returns the collection of HTTP POST fields to be used when accessing a web page in converter.
  `NameValuePairsCollection`
  `httpRequestCookies()`
  Gets a collection of custom HTTP cookies to be sent by converter to the web server when the web page to convert and the resources (image, css, etc) referenced by the web page are requested.
  `NameValuePairsCollection`
  `httpRequestHeaders()`
  Gets a collection of custom HTTP headers to be sent by converter to the web server when the web page is requested from a URL.
  `int`
  `imagePartSize()`
  Gets the maximum height in pixels of an image part in converter
  `ImpersonationOptions`
  `impersonationOptions()`
  The impersonation options applied during navigation
  `int`
  `initialHtmlViewerHeight()`
  Gets the initial height in pixels of the HTML viewer in converter
  `boolean`
  `insertNewPagesEnabled()`
  Gets the flag indicating if the HTML to image element will always insert a new page in the PDF document when rendering next page instead of trying to use an already existing PDF page
  `boolean`
  `interactiveHiddenElements()`
  Gets the flag indicating if the interactive features are enabled for hidden HTML elements
  `boolean`
  `internalLinksEnabled()`
  Gets the flag indicating if the converter will convert the internal HTML links (links with anchors) to internal PDF links in the PDF document
  `boolean`
  `interruptSlowJavaScript()`
  Gets the flag indicating if the slow JavaScript script should be interrupted in converter.
  `boolean`
  `javaScriptEnabled()`
  Gets the flag indicating if JavaScript execution is enabled in converter
  `boolean`
  `liveUrlsEnabled()`
  Gets the flag indicating if the converter will convert the external links from HTML to PDF links in the PDF document
  `boolean`
  `localFilesAccessEnabled()`
  Gets the a flag indicating if the access to local files is enabled in the HTML to Image element
  `int`
  `manualTriggeringConversionDelay()`
  Gets the additional time in seconds to wait after manual triggering before starting the rendering.
  `int`
  `maxHtmlViewerHeight()`
  Gets the maximum height in pixels to be rendered from the HTML document by converter
  `String`
  `mediaType()`
  Gets the media type of the HTML document used by converter.
  `int`
  `minHtmlViewerHeight()`
  Gets the minimum height in pixels to be rendered from the HTML document by converter
  `int`
  `navigationTimeout()`
  Gets the navigation timeout in seconds
  `String`
  `navigatorUserAgent()`
  Gets the custom user agent to be used when accessing the HTML page
  `String[]`
  `pageBreakAfterHtmlElementsSelectors()`
  Gets the CSS selectors of the HTML elements after which to force a page break in PDF document
  `String[]`
  `pageBreakBeforeHtmlElementsSelectors()`
  Gets the CSS selectors of the HTML elements before which to force a page break in PDF document
  `boolean`
  `paginate()`
  Gets the flag indicating if the HTML to image element can be paginated to render many PDF pages if necessary
  `PdfBookmarkOptions`
  `pdfBookmarkOptions()`
  Gets a reference to the object controlling the bookmarks creation for the rendered PDF document.
  `boolean`
  `persistentHttpRequestHeaders()`
  Gets the flag indicating if the converter will send the custom headers defined by the `httpRequestHeaders()` property each time an external resource (image, css, etc) referenced by the web page is requested
  `boolean`
  `prerenderEnabled()`
  Gets the flag indicating if the converter should perform a pre-rendering
  `ProxyOptions`
  `proxyOptions()`
  Gets a reference to an object encapsulating the proxy options used by converter to access the HTML document to convert
  `String`
  `renderedHtmlElementSelector()`
  Gets the CSS selector of the HTML element to be rendered to PDF by converter
  `PdfRectangle[]`
  `renderedPagesRectangles()`
  Gets the bounds of the rendered rectangle on each PDF page.
  `void`
  `setAvoidHtmlElementsBreakSelectors(String[] selectors)`
  Sets the CSS selectors of the HTML elements to not be broken between PDF pages if possible.
  `void`
  `setAvoidImageBreak(boolean avoidImageBreak)`
  Sets the flag indicating if the converter will try to avoid cutting off the images between PDF pages
  `void`
  `setBaseUrl(String htmlStringBaseURL)`
  Sets the base URL of the HTML string to be converted to PDF
  `void`
  `setBottomSpacing(float bottomSpacing)`
  Sets the space in points to introduce at the bottom of PDF pages where the HTML is rendered.
  `void`
  `setClipHtmlView(boolean clipView)`
  Sets a flag indicating if the HTML content is clipped by HTML viewer window width.
  `void`
  `setConversionDelay(int delay)`
  Sets an additional time in seconds to wait for asynchronous items to be completely loaded or for a web page redirect to finish before starting the rendering in converter.
  `void`
  `setDefaultHtmlEncoding(String encoding)`
  Sets the default HTML document text encoding to be used if there is no charset meta tag defined in the HTML document
  `void`
  `setDownloadAllResources(boolean download)`
  Sets the flag indicating if the converter should try to download all the resources even if this could cause a slower conversion.
  `void`
  `setEnable3DTransformations(boolean enabled)`
  Gets or sets a flag indicating if the accelerated CSS 3D transformations are enabled in converter.
  `void`
  `setEnableAccelerated2DCanvas(boolean enabled)`
  Sets the flag indicating if the accelerated 2D canvas is enabled in converter.
  `void`
  `setEnableHttp2(boolean enabled)`
  Sets the flag indicating if the the HTTP2 protocol is enabled in in HTML to Image element converter.
  `void`
  `setEnablePersistentStorage(boolean enabled)`
  Sets the flag indicating if the persistent local storage is enabled in converter.
  `void`
  `setEnableWebGL(boolean enabled)`
  Sets a flag indicating if the WebGL is enabled in converter.
  `void`
  `setExtensionsEnabled(boolean enabled)`
  Sets a flag indicating if the HTML viewer extensions are executed during conversion.
  `void`
  `setFitHeight(boolean fitHeight)`
  Sets the fag indicating if the HTML content will be resized if necessary to fit the available height in PDF page.
  `void`
  `setFitWidth(boolean fitWidth)`
  Sets the fag indicating if the HTML content will be resized if necessary to fit the available width in PDF page.
  `void`
  `setHeight(float height)`
  Sets the height in points of the destination rectangle in PDF page where the HTML content is rendered.
  `void`
  `setHtml(String htmlStringToConvert)`
  Sets the HTML string to be converted to PDF
  `void`
  `setHtmlViewerHeight(int viewerHeight)`
  Sets the HTML viewer height in pixels in the HTML to image converter element.
  `void`
  `setHtmlViewerWidth(int viewerWidth)`
  Gets or sets the preferred HTML viewer width in pixels in HTML to image converter element.
  `void`
  `setHtmlViewerZoom(int viewerZoom)`
  Sets HTML viewer zoom percentage in HTML to Image element similar to zoom level in a browser.
  `void`
  `setImagePartSize(int height)`
  Sets the maximum height in pixels of an image part in converter
  `void`
  `setInitialHtmlViewerHeight(int initialHeight)`
  Sets the initial height in pixels of the HTML viewer in converter.
  `void`
  `setInsertNewPagesEnabled(boolean insertNewPagesEnabled)`
  Sets the flag indicating if the HTML to image element will always insert a new page in the PDF document when rendering next page instead of trying to use an already existing PDF page.
  `void`
  `setInteractiveHiddenElements(boolean enabled)`
  Sets the flag indicating if the interactive features are enabled for hidden HTML elements.
  `void`
  `setInternalLinksEnabled(boolean enabled)`
  Sets the flag indicating if the converter to convert the internal HTML links (links with anchors) to internal PDF links in the PDF document.
  `void`
  `setInterruptSlowJavaScript(boolean interrupt)`
  Sets a flag indicating if the slow JavaScript script should be interrupted in converter.
  `void`
  `setJavaScriptEnabled(boolean enabled)`
  Sets a flag indicating if JavaScript execution is enabled in converter.
  `void`
  `setLiveUrlsEnabled(boolean enabled)`
  Sets the flag indicating if the converter will convert the external links from HTML to PDF links in the PD.
  `void`
  `setLocalFilesAccessEnabled(boolean enabled)`
  Sets the flag indicating if the access to local files is enabled in the HTML to Image element.
  `void`
  `setManualTriggeringConversionDelay(int delay)`
  Sets an additional time in seconds to wait after manual triggering before starting the rendering.
  `void`
  `setMaxHtmlViewerHeight(int maxHeight)`
  Sets the maximum height in pixels to be rendered from the HTML document by converter.
  `void`
  `setMediaType(String media)`
  Sets the media type of the HTML document used by converter.
  `void`
  `setMinHtmlViewerHeight(int minHeight)`
  Sets the minimum height in pixels to be rendered from the HTML document by converter.
  `void`
  `setNavigationTimeout(int timeout)`
  Sets the converter navigation timeout in seconds.
  `void`
  `setNavigatorUserAgent(String navigatorUserAgent)`
  Sets the custom user agent to be used when accessing the HTML page.
  `void`
  `setPageBreakAfterHtmlElementsSelectors(String[] selectors)`
  Sets the CSS selectors of the HTML elements after which to force a page break in PDF document
  `void`
  `setPageBreakBeforeHtmlElementsSelectors(String[] selectors)`
  Sets the CSS selectors of the HTML elements before which to force a page break in PDF document
  `void`
  `setPaginate(boolean paginate)`
  Sets the flag indicating if the HTML to image element can be paginated to render many PDF pages if necessary
  `void`
  `setPersistentHttpRequestHeaders(boolean persistentHttpRequestHeaders)`
  Sets the flag indicating if the converter will send the custom headers defined by the `httpRequestHeaders()` property each time an external resource (image, css, etc) referenced by the web page is requested.
  `void`
  `setPrerenderEnabled(boolean enabled)`
  Sets a flag indicating if the converter should perform a pre-rendering.
  `void`
  `setRenderedHtmlElementSelector(String selector)`
  Gets or sets the CSS selector of the HTML element to be rendered to PDF by converter.
  `void`
  `setShowFooterInEvenPages(boolean showFooterInEvenPages)`
  Sets flag indicating if the footer is displayed in the even pages of the PDF document where this element is rendered
  `void`
  `setShowFooterInOddPages(boolean showFooterInOddPages)`
  Sets the flag indicating if the footer is displayed in the odd pages of the PDF document where this element is rendered
  `void`
  `setShowHeaderInEvenPages(boolean showHeaderInEvenPages)`
  Sets flag indicating if the header is displayed in the even pages of the PDF document where this element is rendered
  `void`
  `setShowHeaderInOddPages(boolean showHeaderInOddPages)`
  Sets the flag indicating if the header is displayed in the odd pages of the PDF document where this element is rendered
  `void`
  `setStretchToFit(boolean stretchToFit)`
  Sets the value of the flag indicating if the HTML content will be stretched if necessary to fit the available width in PDF page.
  `void`
  `setSvgFontsEnabled(boolean enabled)`
  Sets a flag indicating if the SVG fonts are enabled in HTML during conversion.
  `void`
  `setTableOfContentsEnabled(boolean enabled)`
  Sets flag indicating if this HTML to Image element can contribute to the PDF document table of contents.
  `void`
  `setTopSpacing(float topSpacig)`
  Sets the space in points to introduce at the top of PDF pages where the HTML is rendered.
  `void`
  `setTriggeringMode(TriggeringMode mode)`
  Sets the conversion triggering mode used by converter
  `void`
  `setUrl(String urlToConvert)`
  Sets the URL of the HTML document to be converted to PDF
  `void`
  `setWebFontsEnabled(boolean enabled)`
  Sets the flag indicating if the Web Fonts are enabled in HTML during conversion.
  `void`
  `setWidth(float width)`
  Sets the width in points of the destination rectangle in PDF page where the HTML content is rendered.
  `void`
  `setX(float x)`
  Sets the X coordinate in points where to start HTML rendering in first page.
  `void`
  `setXPSupplementalLanguages(boolean enabled)`
  Sets the flag in converter indicating if the supplemental languages (complex script, right-to-left, East Asian) support was enabled in Windows XP Regional and Language Options.
  `void`
  `setY(float y)`
  Sets the Y coordinate in points where to start HTML rendering in first page.
  `boolean`
  `showFooterInEvenPages()`
  Gets the flag indicating if the footer is displayed in the even pages of the PDF document where this element is rendered
  `boolean`
  `showFooterInOddPages()`
  Gets the flag indicating if the footer is displayed in the odd pages of the PDF document where this element is rendered
  `boolean`
  `showHeaderInEvenPages()`
  Gets the flag indicating if the header is displayed in the even pages of the PDF document where this element is rendered
  `boolean`
  `showHeaderInOddPages()`
  Gets the flag indicating if the header is displayed in the odd pages of the PDF document where this element is rendered
  `boolean`
  `stretchToFit()`
  Gets the value of the flag indicating if the HTML content will be stretched if necessary to fit the available width in PDF page
  `boolean`
  `svgFontsEnabled()`
  Gets the flag indicating if the SVG fonts are enabled in HTML during conversion.
  `boolean`
  `tableOfContentsEnabled()`
  Gets the flag indicating if this HTML to Image element can contribute to the PDF document table of contents
  `float`
  `topSpacing()`
  Gets the space in points to introduce at the top of PDF pages where the HTML is rendered.
  `TriggeringMode`
  `triggeringMode()`
  Gets the conversion triggering mode used by converter
  `String`
  `url()`
  Gets the URL of the HTML document to be converted to PDF
  `boolean`
  `webFontsEnabled()`
  Gets the flag indicating if the Web Fonts are enabled in HTML during conversion.
  `float`
  `width()`
  Gets the width in points of the destination rectangle in PDF page where the HTML content is rendered
  `float`
  `x()`
  Gets the X coordinate in points where to start HTML rendering in first page.
  `boolean`
  `xpSupplementalLanguages()`
  Gets the flag in converter indicating if the supplemental languages (complex script, right-to-left, East Asian) support was enabled in Windows XP Regional and Language Options
  `float`
  `y()`
  Gets the Y coordinate in points where to start HTML rendering in first page.

  ### Methods inherited from class com.evopdf.PageGraphicElement

  `backColor, blending, clipRectangle, foreColor, gradient, lineStyle, opacity, rotate, scale, setBackColor, setBlending, setClipRectangle, setForeColor, setGradient, setLineStyle, setOpacity, skew, translate`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_HTML_VIEWER_WIDTH_PX

    public static final int DEFAULT_HTML_VIEWER_WIDTH_PX
    The default virtual browser width in pixels
    See Also:
      - Constant Field Values

  - ### AUTO_HTML_VIEWER_HEIGHT_PX

    public static final int AUTO_HTML_VIEWER_HEIGHT_PX
    The default virtual browser height in pixels is set to autodetect the HTML content height
    See Also:
      - Constant Field Values

  - ### AVAILABLE_PDF_WIDTH_POINTS

    public static final int AVAILABLE_PDF_WIDTH_POINTS
    The default width in PDF of the element is set to available width in PDF page.
    See Also:
      - Constant Field Values

  - ### AUTO_PDF_HEIGHT_POINTS

    public static final int AUTO_PDF_HEIGHT_POINTS
    The default width in PDF of the element is set to available width in PDF page.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### HtmlToImageElement

    public HtmlToImageElement(String htmlStringToConvert, String htmlStringBaseURL)
    Creates a HTML string to image converter element that will be rendered at the (0,0) location in PDF page using a base URL to resolve the external resources and a document URL to resolve the internal links. The width of element in PDF page is the available width in PDF page and the height is auto determined
    Parameters:
      `htmlStringToConvert` - The HTML string to convert to image
      `htmlStringBaseURL` - The full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL

  - ### HtmlToImageElement

    public HtmlToImageElement(String urlToConvert)
    Creates an URL to image converter element at the (0,0) location in PDF page. The width of element in PDF page is the available width in PDF page and the height is auto determined
    Parameters:
      `urlToConvert` - the URL to convert to image

  - ### HtmlToImageElement

    public HtmlToImageElement(float x, float y, String htmlStringToConvert, String htmlStringBaseURL)
    Creates a HTML string to image converter element at the specified x and y coordinates in PDF page using a base URL to resolve the external resources and a document URL to resolve the internal links. The width of element in PDF page is the available width in PDF page and the height is auto determined
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `htmlStringToConvert` - the HTML string to convert to image
      `htmlStringBaseURL` - the full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL. When this parameter is NULL no base URL will be used

  - ### HtmlToImageElement

    public HtmlToImageElement(float x, float y, String urlToConvert)
    Creates an URL to image converter element at the specified x and y coordinates in PDF page. The width of element in PDF page is the available width in PDF page and the height is auto determined
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `urlToConvert` - the URL to convert to image

  - ### HtmlToImageElement

    public HtmlToImageElement(float x, float y, float width, String htmlStringToConvert, String htmlStringBaseURL)
    Creates a HTML string to image converter element at the specified x and y coordinates with the specified width using a base URL to resolve the external resources and a document URL to resolve the internal links. The height in PDF is auto determined
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `htmlStringToConvert` - the HTML string to convert to image
      `htmlStringBaseURL` - the full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL. When this parameter is NULL no base URL will be used

  - ### HtmlToImageElement

    public HtmlToImageElement(float x, float y, float width, String urlToConvert)
    Creates an URL to image converter element at the specified x and y coordinates with the specified width. The height in PDF is auto determined
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `urlToConvert` - the URL to convert to image

  - ### HtmlToImageElement

    public HtmlToImageElement(float x, float y, float width, float height, String htmlStringToConvert, String htmlStringBaseURL)
    Creates a HTML string to image converter element at the specified x and y coordinates with the specified width and height using a base URL to resolve the external resources and a document URL to resolve the internal links
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `height` - the destination height in points for the rendered content. If the specified height is less or equal 0, the destination height will be auto determined so all the content can be rendered. Please note that the specified height is the effective height that will be rendered in the PDF document and does not include for example the empty spaces introduced by custom or automatic page breaks
      `htmlStringToConvert` - the HTML string to convert to image
      `htmlStringBaseURL` - the full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL. When this parameter is NULL no base URL will be used

  - ### HtmlToImageElement

    public HtmlToImageElement(float x, float y, float width, float height, String urlToConvert)
    Creates an URL to image converter element at the specified x and y coordinates with the specified width and height
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `height` - the destination height in points for the rendered content. If the specified height is less or equal 0, the destination height will be auto determined so all the content can be rendered. Please note that the specified height is the effective height that will be rendered in the PDF document and does not include for example the empty spaces introduced by custom or automatic page breaks
      `urlToConvert` - the URL to convert to image

  - ### HtmlToImageElement

    public HtmlToImageElement(float x, float y, float width, String htmlStringToConvert, String htmlStringBaseURL, int htmlViewerWidth)
    Creates a HTML string to image converter element at the specified x and y coordinates with the specified width using a base URL to resolve the external resources and a document URL to resolve the internal links. The height in PDF is auto determined. The virtual browser width in pixels is specified by the htmlViewerWidth parameter
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `htmlStringToConvert` - the HTML string convert to image
      `htmlStringBaseURL` - the full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL. When this parameter is NULL no base URL will be used
      `htmlViewerWidth` - the virtual browser width in pixels. The default value is 1024 pixels. The effect of this parameter is similar with viewing the HTML page in a browser window with the specified width

  - ### HtmlToImageElement

    public HtmlToImageElement(float x, float y, float width, String urlToConvert, int htmlViewerWidth)
    Creates an URL to image converter element at the specified x and y coordinates with the specified width. The height in PDF is auto determined. The virtual browser width in pixels is specified by the htmlViewerWidth parameter
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `urlToConvert` - the URL to convert to image
      `htmlViewerWidth` - the virtual browser width in pixels. The default value is 1024 pixels. The effect of this parameter is similar with viewing the HTML page in a browser window with the specified width

  - ### HtmlToImageElement

    public HtmlToImageElement(float x, float y, float width, float height, String htmlStringToConvert, String htmlStringBaseURL, int htmlViewerWidth, int htmlViewerHeight)
    Creates a HTML string to image converter element at the specified x and y coordinates with the specified width and height using a base URL to resolve the external resources and a document URL to resolve the internal links. The virtual browser width and height in pixels is specified by the htmlViewerWidth and htmlViewerHeight parameters
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `height` - the destination height in points for the rendered content. If the specified height is less or equal 0, the destination height will be auto determined so all the content can be rendered. Please note that the specified height is the effective height that will be rendered in the PDF document and does not include for example the empty spaces introduced by custom or automatic page breaks
      `htmlStringToConvert` - the HTML string convert to image
      `htmlStringBaseURL` - the full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL. When this parameter is NULL no base URL will be used
      `htmlViewerWidth` - the virtual browser width in pixels. The default value is 1024 pixels. The effect of this parameter is similar with viewing the HTML page in a browser window with the specified width
      `htmlViewerHeight` - the virtual browser height in pixels. The default value is 0 which means the height will be auto-determined. The effect of this parameter is similar with viewing the HTML page in a browser window with the specified width and height. When this parameter is less or equal to 0, the converter will try to auto-determine the HTML page height from the HTML document content

  - ### HtmlToImageElement

    public HtmlToImageElement(float x, float y, float width, float height, String urlToConvert, int htmlViewerWidth, int htmlViewerHeight)
    Creates a URL to image converter element at the specified x and y coordinates with the specified width and height using a document URL to resolve the internal links. The virtual browser width and height in pixels are specified by the htmlViewerWidth and htmlViewerHeight parameters
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `height` - the destination height in points for the rendered content. If the specified height is less or equal 0, the destination height will be auto determined so all the content can be rendered. Please note that the specified height is the effective height that will be rendered in the PDF document and does not include for example the empty spaces introduced by custom or automatic page breaks
      `urlToConvert` - the URL to convert to image
      `htmlViewerWidth` - the virtual browser width in pixels. The default value is 1024 pixels. The effect of this parameter is similar with viewing the HTML page in a browser window with the specified width
      `htmlViewerHeight` - the virtual browser height in pixels. The default value is 0 which means the height will be auto-determined. The effect of this parameter is similar with viewing the HTML page in a browser window with the specified width and height. When this parameter is less or equal to 0, the converter will try to auto-determine the HTML page height from the HTML document content

- ## Method Details

  - ### htmlViewerWidth

    public int htmlViewerWidth()
    Gets the preferred HTML viewer width in pixels in HTML to image converter element
    Returns:
      the preferred HTML viewer width in pixels

  - ### setHtmlViewerWidth

    public void setHtmlViewerWidth(int viewerWidth)
    Gets or sets the preferred HTML viewer width in pixels in HTML to image converter element. If the HTML content is not entirely visible in the HTML viewer at the specified width, the `clipHtmlView()` property will control whether the HTML content is clipped or the HTML viewer width is automatically extended to make visible the whole HTML content. By default the `clipHtmlView()` property is false and the HTML viewer is automatically extended in width to make visible the whole HTML content. The HTML viewer width can also be specified in the HtmlToImageElement class constructor. The default value is 1024 pixels
    Parameters:
      `viewerWidth` - the HTML viewer width to set

  - ### htmlViewerHeight

    public int htmlViewerHeight()
    Gets the HTML viewer height in pixels in the HTML to image converter element.
    Returns:
      the HTML viewer height

  - ### setHtmlViewerHeight

    public void setHtmlViewerHeight(int viewerHeight)
    Sets the HTML viewer height in pixels in the HTML to image converter element. If the specified HTML viewer height is 0 the HTML viewer height will be automatically determined based on the HTML content and the HTML viewer width in order to make visible the whole HTML content. The HTML viewer width is given by the `htmlViewerWidth()` property of the `HtmlToImageElement` class. If the HTML content is not entirely visible in the HTML viewer at the specified width, the `clipHtmlView()` property will control whether the HTML content is clipped or the HTML viewer width is automatically extended to make visible the whole HTML content. The HTML viewer height can also be specified in the `HtmlToImageElement` class constructor. The default value is 0 to automatically determine the HTML viewer height based on the HTML content and the HTML viewer width
    Parameters:
      `viewerHeight` - the HTML viewer height to set

  - ### navigatorUserAgent

    public String navigatorUserAgent()
    Gets the custom user agent to be used when accessing the HTML page
    Returns:
      the custom user agent

  - ### setNavigatorUserAgent

    public void setNavigatorUserAgent(String navigatorUserAgent)
    Sets the custom user agent to be used when accessing the HTML page. When this property is null or empty the default user agent is used
    Parameters:
      `navigatorUserAgent` - the custom user agent to set

  - ### htmlViewerZoom

    public int htmlViewerZoom()
    Gets the HTML viewer zoom percentage in HTML to Image element similar to zoom level in a browser
    Returns:
      the HTML viewer zoom

  - ### setHtmlViewerZoom

    public void setHtmlViewerZoom(int viewerZoom)
    Sets HTML viewer zoom percentage in HTML to Image element similar to zoom level in a browser. The default value of this property is 100
    Parameters:
      `viewerZoom` - the HTML viewer zoom to set

  - ### clipHtmlView

    public boolean clipHtmlView()
    Gets a flag indicating if the HTML content is clipped by HTML viewer window width.
    Returns:
      the HTML content clipping option

  - ### setClipHtmlView

    public void setClipHtmlView(boolean clipView)
    Sets a flag indicating if the HTML content is clipped by HTML viewer window width. If the HTML content is not entirely visible in the HTML viewer at the specified width, this property will control whether the HTML content is clipped or the HTML viewer width is automatically extended to make visible the whole HTML content. The HTML viewer width is given by the `htmlViewerWidth()` property. The default value of this property is false
    Parameters:
      `clipView` - the HTML clipping option value

  - ### url

    public String url()
    Gets the URL of the HTML document to be converted to PDF
    Returns:
      the URL of the HTML document to be converted to PDF

  - ### setUrl

    public void setUrl(String urlToConvert)
    Sets the URL of the HTML document to be converted to PDF
    Parameters:
      `urlToConvert` - the URL of the HTML document to be converted to PDF

  - ### html

    public String html()
    Gets the HTML string to be converted to PDF
    Returns:
      the HTML string to be converted to PDF

  - ### setHtml

    public void setHtml(String htmlStringToConvert)
    Sets the HTML string to be converted to PDF
    Parameters:
      `htmlStringToConvert` - the HTML string to be converted to PDF

  - ### baseUrl

    public String baseUrl()
    Gets the base URL of the HTML string to be converted to PDF
    Returns:
      the base URL of the HTML string to be converted to PDF

  - ### setBaseUrl

    public void setBaseUrl(String htmlStringBaseURL)
    Sets the base URL of the HTML string to be converted to PDF
    Parameters:
      `htmlStringBaseURL` - the base URL of the HTML string to be converted to PDF

  - ### x

    public float x()
    Gets the X coordinate in points where to start HTML rendering in first page.
    Returns:
      the X coordinate

  - ### setX

    public void setX(float x)
    Sets the X coordinate in points where to start HTML rendering in first page. By default the left location is 0.
    Parameters:
      `x` - the X coordinate

  - ### y

    public float y()
    Gets the Y coordinate in points where to start HTML rendering in first page. By default the top location is 0
    Returns:
      the Y coordinate

  - ### setY

    public void setY(float y)
    Sets the Y coordinate in points where to start HTML rendering in first page. By default the top location is 0
    Parameters:
      `y` - the Y coordinate

  - ### width

    public float width()
    Gets the width in points of the destination rectangle in PDF page where the HTML content is rendered
    Returns:
      the width in points of the destination rectangle

  - ### setWidth

    public void setWidth(float width)
    Sets the width in points of the destination rectangle in PDF page where the HTML content is rendered. By default the destination width is the available width in PDF page
    Parameters:
      `width` - the width in points of the destination rectangle

  - ### height

    public float height()
    Gets the height in points of the destination rectangle in PDF page where the HTML content is rendered
    Returns:
      the height in points of the destination rectangle

  - ### setHeight

    public void setHeight(float height)
    Sets the height in points of the destination rectangle in PDF page where the HTML content is rendered. By default the destination height is automatically calculated to render the whole HTML content
    Parameters:
      `height` - the height in points of the destination rectangle

  - ### topSpacing

    public float topSpacing()
    Gets the space in points to introduce at the top of PDF pages where the HTML is rendered. 1 point is 1/72 inch
    Returns:
      the space in points to introduce at the top of PDF pages

  - ### setTopSpacing

    public void setTopSpacing(float topSpacig)
    Sets the space in points to introduce at the top of PDF pages where the HTML is rendered. 1 point is 1/72 inch. By default the top spacing is 0
    Parameters:
      `topSpacig` - the space in points to introduce at the top of PDF pages

  - ### bottomSpacing

    public float bottomSpacing()
    Gets the space in points to introduce at the bottom of PDF pages where the HTML is rendered. 1 point is 1/72 inch. By default the bottom spacing is 0
    Returns:
      the space in points to introduce at the bottom of PDF pages

  - ### setBottomSpacing

    public void setBottomSpacing(float bottomSpacing)
    Sets the space in points to introduce at the bottom of PDF pages where the HTML is rendered. 1 point is 1/72 inch. By default the bottom spacing is 0
    Parameters:
      `bottomSpacing` - the space in points to introduce at the bottom of PDF pages

  - ### fitWidth

    public boolean fitWidth()
    Gets the fag indicating if the HTML content will be resized if necessary to fit the available width in PDF page
    Returns:
      the flag value

  - ### setFitWidth

    public void setFitWidth(boolean fitWidth)
    Sets the fag indicating if the HTML content will be resized if necessary to fit the available width in PDF page. When false the HTML content will be rendered at the real size. By default this property is true and the content will be resized if necessary to fit the available width in PDF page
    Parameters:
      `fitWidth` - the flag value to set

  - ### fitHeight

    public boolean fitHeight()
    Gets the fag indicating if the HTML content will be resized if necessary to fit the available height in PDF page
    Returns:
      the flag value

  - ### setFitHeight

    public void setFitHeight(boolean fitHeight)
    Sets the fag indicating if the HTML content will be resized if necessary to fit the available height in PDF page. By default this property is false
    Parameters:
      `fitHeight` - the flag value to set

  - ### stretchToFit

    public boolean stretchToFit()
    Gets the value of the flag indicating if the HTML content will be stretched if necessary to fit the available width in PDF page
    Returns:
      the flag value

  - ### setStretchToFit

    public void setStretchToFit(boolean stretchToFit)
    Sets the value of the flag indicating if the HTML content will be stretched if necessary to fit the available width in PDF page. This property has effect in converter only when `fitWidth()` property is true. When `fitWidth()` is true and this property is true the HTML content will be stretched if necessary to fit the available width in PDF page. By default this property is false and the content will not be stretched to fit the available width in PDF page
    Parameters:
      `stretchToFit` - the flag value to set

  - ### insertNewPagesEnabled

    public boolean insertNewPagesEnabled()
    Gets the flag indicating if the HTML to image element will always insert a new page in the PDF document when rendering next page instead of trying to use an already existing PDF page
    Returns:
      the flag value

  - ### setInsertNewPagesEnabled

    public void setInsertNewPagesEnabled(boolean insertNewPagesEnabled)
    Sets the flag indicating if the HTML to image element will always insert a new page in the PDF document when rendering next page instead of trying to use an already existing PDF page. This property is false by default
    Parameters:
      `insertNewPagesEnabled` - the flag valur to set

  - ### liveUrlsEnabled

    public boolean liveUrlsEnabled()
    Gets the flag indicating if the converter will convert the external links from HTML to PDF links in the PDF document
    Returns:
      the flag value

  - ### setLiveUrlsEnabled

    public void setLiveUrlsEnabled(boolean enabled)
    Sets the flag indicating if the converter will convert the external links from HTML to PDF links in the PD. The default value is true
    Parameters:
      `enabled` - the flag value to set

  - ### interactiveHiddenElements

    public boolean interactiveHiddenElements()
    Gets the flag indicating if the interactive features are enabled for hidden HTML elements
    Returns:
      the flag value

  - ### setInteractiveHiddenElements

    public void setInteractiveHiddenElements(boolean enabled)
    Sets the flag indicating if the interactive features are enabled for hidden HTML elements. This property is false by default
    Parameters:
      `enabled` - the flag value to set

  - ### internalLinksEnabled

    public boolean internalLinksEnabled()
    Gets the flag indicating if the converter will convert the internal HTML links (links with anchors) to internal PDF links in the PDF document
    Returns:
      the flag value

  - ### setInternalLinksEnabled

    public void setInternalLinksEnabled(boolean enabled)
    Sets the flag indicating if the converter to convert the internal HTML links (links with anchors) to internal PDF links in the PDF document. The default value is true
    Parameters:
      `enabled` - the flag value to set

  - ### javaScriptEnabled

    public boolean javaScriptEnabled()
    Gets the flag indicating if JavaScript execution is enabled in converter
    Returns:
      the flag indicating if JavaScript execution is enabled in converter

  - ### setJavaScriptEnabled

    public void setJavaScriptEnabled(boolean enabled)
    Sets a flag indicating if JavaScript execution is enabled in converter. The default is true
    Parameters:
      `enabled` - the flag value to set

  - ### enable3DTransformations

    public boolean enable3DTransformations()
    Gets the flag indicating if the accelerated CSS 3D transformations are enabled in converter. The default value is false
    Returns:
      the flag indicating if the accelerated CSS 3D transformations are enabled in converter

  - ### setEnable3DTransformations

    public void setEnable3DTransformations(boolean enabled)
    Gets or sets a flag indicating if the accelerated CSS 3D transformations are enabled in converter. The default value is false
    Parameters:
      `enabled` - the flag value to set

  - ### enableWebGL

    public boolean enableWebGL()
    Gets the flag indicating if the WebGL is enabled in converter
    Returns:
      the flag indicating if the WebGL is enabled in converter

  - ### setEnableWebGL

    public void setEnableWebGL(boolean enabled)
    Sets a flag indicating if the WebGL is enabled in converter. The default value is false
    Parameters:
      `enabled` - the flag value to set

  - ### enableAccelerated2DCanvas

    public boolean enableAccelerated2DCanvas()
    Gets the flag indicating if the accelerated 2D canvas is enabled in converter
    Returns:
      the flag indicating if the accelerated 2D canvas is enabled in converter

  - ### setEnableAccelerated2DCanvas

    public void setEnableAccelerated2DCanvas(boolean enabled)
    Sets the flag indicating if the accelerated 2D canvas is enabled in converter. The default value is false
    Parameters:
      `enabled` - the flag value to set

  - ### enablePersistentStorage

    public boolean enablePersistentStorage()
    Gets the flag indicating if the persistent local storage is enabled in converter
    Returns:
      the flag indicating if the persistent local storage is enabled in converter

  - ### setEnablePersistentStorage

    public void setEnablePersistentStorage(boolean enabled)
    Sets the flag indicating if the persistent local storage is enabled in converter. The default value is false
    Parameters:
      `enabled` - the flag value to set

  - ### localFilesAccessEnabled

    public boolean localFilesAccessEnabled()
    Gets the a flag indicating if the access to local files is enabled in the HTML to Image element
    Returns:
      flag indicating if the access to local files is enabled in the HTML to Image element

  - ### setLocalFilesAccessEnabled

    public void setLocalFilesAccessEnabled(boolean enabled)
    Sets the flag indicating if the access to local files is enabled in the HTML to Image element. The default value is true
    Parameters:
      `enabled` - the flag value to set

  - ### paginate

    public boolean paginate()
    Gets the flag indicating if the HTML to image element can be paginated to render many PDF pages if necessary
    Returns:
      the flag value

  - ### setPaginate

    public void setPaginate(boolean paginate)
    Sets the flag indicating if the HTML to image element can be paginated to render many PDF pages if necessary
    Parameters:
      `paginate` - the flag value to set

  - ### httpPostFields

    public NameValuePairsCollection httpPostFields()
    Returns the collection of HTTP POST fields to be used when accessing a web page in converter. If there are elements in collection then the converter will make a POST request to the web page URL with the fields from this collection, otherwise it will make a GET request
    Returns:
      the collection of HTTP POST fields to be used when accessing a web page in converter

  - ### mediaType

    public String mediaType()
    Gets the media type of the HTML document used by converter.
    Returns:
      the media type used by converter

  - ### setMediaType

    public void setMediaType(String media)
    Sets the media type of the HTML document used by converter. The default media type is 'screen'. If you set this property with 'print' then the CSS properties defined in '@media print' rule will be used to render the document
    Parameters:
      `media` - the media type to be used by converter

  - ### svgFontsEnabled

    public boolean svgFontsEnabled()
    Gets the flag indicating if the SVG fonts are enabled in HTML during conversion.
    Returns:
      the flag indicating if the SVG fonts are enabled

  - ### setSvgFontsEnabled

    public void setSvgFontsEnabled(boolean enabled)
    Sets a flag indicating if the SVG fonts are enabled in HTML during conversion. The default value is false
    Parameters:
      `enabled` - the flag value to set

  - ### webFontsEnabled

    public boolean webFontsEnabled()
    Gets the flag indicating if the Web Fonts are enabled in HTML during conversion.
    Returns:
      the flag indicating if the Web Fonts are enabled

  - ### setWebFontsEnabled

    public void setWebFontsEnabled(boolean enabled)
    Sets the flag indicating if the Web Fonts are enabled in HTML during conversion.
    Parameters:
      `enabled` - the flag value to set

  - ### enableHttp2

    public boolean enableHttp2()
    Gets the flag indicating if the HTTP2 protocol is enabled in in HTML to Image element converter. The property has effect only with NE version of the server
    Returns:
      the flag indicating if the HTTP2 protocol is enabled

  - ### setEnableHttp2

    public void setEnableHttp2(boolean enabled)
    Sets the flag indicating if the the HTTP2 protocol is enabled in in HTML to Image element converter. The property has effect only with NE version of the server. The default value is false
    Parameters:
      `enabled` - the flag value to set

  - ### extensionsEnabled

    public boolean extensionsEnabled()
    Gets the flag indicating if the HTML viewer extensions are executed during conversion.
    Returns:
      the flag indicating if the HTML viewer extensions are executed

  - ### setExtensionsEnabled

    public void setExtensionsEnabled(boolean enabled)
    Sets a flag indicating if the HTML viewer extensions are executed during conversion. The default value is false and no extension is executed. The Flash player for Mozilla Firefox must be installed in order to execute the flash content from HTML
    Parameters:
      `enabled` - the flag value to set

  - ### downloadAllResources

    public boolean downloadAllResources()
    Gets the flag indicating if the converter should try to download all the resources
    Returns:
      the flag indicating if the converter should try to download all the resources

  - ### setDownloadAllResources

    public void setDownloadAllResources(boolean download)
    Sets the flag indicating if the converter should try to download all the resources even if this could cause a slower conversion. The default value is false
    Parameters:
      `download` - the flag value to set

  - ### prerenderEnabled

    public boolean prerenderEnabled()
    Gets the flag indicating if the converter should perform a pre-rendering
    Returns:
      the flag indicating if the converter should perform a pre-rendering

  - ### setPrerenderEnabled

    public void setPrerenderEnabled(boolean enabled)
    Sets a flag indicating if the converter should perform a pre-rendering. The default value is false
    Parameters:
      `enabled` - the flag value to set

  - ### interruptSlowJavaScript

    public boolean interruptSlowJavaScript()
    Gets the flag indicating if the slow JavaScript script should be interrupted in converter.
    Returns:
      the flag indicating if the slow JavaScript script should be interrupted

  - ### setInterruptSlowJavaScript

    public void setInterruptSlowJavaScript(boolean interrupt)
    Sets a flag indicating if the slow JavaScript script should be interrupted in converter. The default value is false and the scripts are not interrupted
    Parameters:
      `interrupt` - the flag value to set

  - ### renderedHtmlElementSelector

    public String renderedHtmlElementSelector()
    Gets the CSS selector of the HTML element to be rendered to PDF by converter
    Returns:
      the selector of the HTML element to be rendered

  - ### setRenderedHtmlElementSelector

    public void setRenderedHtmlElementSelector(String selector)
    Gets or sets the CSS selector of the HTML element to be rendered to PDF by converter. If the selector selects multiple HTML elements, only the the first one will be converted. The CSS selector is case sensitive. If this property is not set then the entire HTML document is rendered
    Parameters:
      `selector` - the CSS selector of the HTML element to be rendered to PDF

  - ### maxHtmlViewerHeight

    public int maxHtmlViewerHeight()
    Gets the maximum height in pixels to be rendered from the HTML document by converter
    Returns:
      the maximum height in pixels to be rendered from the HTML document

  - ### setMaxHtmlViewerHeight

    public void setMaxHtmlViewerHeight(int maxHeight)
    Sets the maximum height in pixels to be rendered from the HTML document by converter. The default value is 0 and the entire HTML document is rendered
    Parameters:
      `maxHeight` - the maximum height in pixels to be rendered from the HTML document

  - ### minHtmlViewerHeight

    public int minHtmlViewerHeight()
    Gets the minimum height in pixels to be rendered from the HTML document by converter
    Returns:
      the minimum height in pixels to be rendered from the HTML document

  - ### setMinHtmlViewerHeight

    public void setMinHtmlViewerHeight(int minHeight)
    Sets the minimum height in pixels to be rendered from the HTML document by converter. The default value is 0 and the entire HTML document is rendered
    Parameters:
      `minHeight` - the minimum height in pixels to be rendered from the HTML document

  - ### initialHtmlViewerHeight

    public int initialHtmlViewerHeight()
    Gets the initial height in pixels of the HTML viewer in converter
    Returns:
      the initial height in pixels of the HTML viewer

  - ### setInitialHtmlViewerHeight

    public void setInitialHtmlViewerHeight(int initialHeight)
    Sets the initial height in pixels of the HTML viewer in converter. This value of this property is ignored if the HtmlViewerHeight property is set
    Parameters:
      `initialHeight` - the initial height in pixels of the HTML viewer

  - ### defaultHtmlEncoding

    public String defaultHtmlEncoding()
    Gets the default HTML document text encoding to be used if there is no charset meta tag defined in the HTML document
    Returns:
      the default HTML document text encoding

  - ### setDefaultHtmlEncoding

    public void setDefaultHtmlEncoding(String encoding)
    Sets the default HTML document text encoding to be used if there is no charset meta tag defined in the HTML document
    Parameters:
      `encoding` - the default HTML document text encoding

  - ### imagePartSize

    public int imagePartSize()
    Gets the maximum height in pixels of an image part in converter
    Returns:
      the maximum height in pixels of an image part

  - ### setImagePartSize

    public void setImagePartSize(int height)
    Sets the maximum height in pixels of an image part in converter
    Parameters:
      `height` - the maximum height in pixels of an image part

  - ### triggeringMode

    public TriggeringMode triggeringMode()
    Gets the conversion triggering mode used by converter
    Returns:
      the conversion triggering mode

  - ### setTriggeringMode

    public void setTriggeringMode(TriggeringMode mode)
    Sets the conversion triggering mode used by converter
    Parameters:
      `mode` - the conversion triggering mode

  - ### conversionDelay

    public int conversionDelay()
    Gets the additional time in seconds to wait for asynchronous items to be completely loaded or for a web page redirect to finish before starting the rendering in converter. Default value is 0
    Returns:
      the additional time in seconds to wait for asynchronous items to be completely loaded

  - ### setConversionDelay

    public void setConversionDelay(int delay)
    Sets an additional time in seconds to wait for asynchronous items to be completely loaded or for a web page redirect to finish before starting the rendering in converter. Default value is 0
    Parameters:
      `delay` - the additional time in seconds to wait for asynchronous items to be completely loaded

  - ### manualTriggeringConversionDelay

    public int manualTriggeringConversionDelay()
    Gets the additional time in seconds to wait after manual triggering before starting the rendering. Default value is 0
    Returns:
      the additional time in seconds to wait

  - ### setManualTriggeringConversionDelay

    public void setManualTriggeringConversionDelay(int delay)
    Sets an additional time in seconds to wait after manual triggering before starting the rendering. Default value is 0
    Parameters:
      `delay` - the additional time in seconds to wait

  - ### navigationTimeout

    public int navigationTimeout()
    Gets the navigation timeout in seconds
    Returns:
      the navigation timeout in seconds

  - ### setNavigationTimeout

    public void setNavigationTimeout(int timeout)
    Sets the converter navigation timeout in seconds. Default value is 60
    Parameters:
      `timeout` - the converter navigation timeout in seconds

  - ### httpRequestHeaders

    public NameValuePairsCollection httpRequestHeaders()
    Gets a collection of custom HTTP headers to be sent by converter to the web server when the web page is requested from a URL. A custom HTTP header is defined by a name and a value pair that can be added to `httpRequestHeaders()` collection. The `persistentHttpRequestHeaders()` property can be set on true to instruct the converter to send the custom headers each time an external resource (image, css, etc) referenced by the web page is requested. By default the `persistentHttpRequestHeaders()` property is false and the custom headers are not automatically sent to the web server when the web page resources are requested. The custom HTTP headers can be used to define cookies, authentication options, URL referrer or any other HTTP header to be sent to the web browser. The preferred method to send cookies is to use the `httpRequestCookies()` property
    Returns:
      the collection of custom HTTP headers to be sent by the converter to the web server

  - ### persistentHttpRequestHeaders

    public boolean persistentHttpRequestHeaders()
    Gets the flag indicating if the converter will send the custom headers defined by the `httpRequestHeaders()` property each time an external resource (image, css, etc) referenced by the web page is requested
    Returns:
      the flag value

  - ### setPersistentHttpRequestHeaders

    public void setPersistentHttpRequestHeaders(boolean persistentHttpRequestHeaders)
    Sets the flag indicating if the converter will send the custom headers defined by the `httpRequestHeaders()` property each time an external resource (image, css, etc) referenced by the web page is requested. The default value of this property is true and the custom headers are automatically sent to the web server when the web page resources are requested
    Parameters:
      `persistentHttpRequestHeaders` - the flag value to set

  - ### httpRequestCookies

    public NameValuePairsCollection httpRequestCookies()
    Gets a collection of custom HTTP cookies to be sent by converter to the web server when the web page to convert and the resources (image, css, etc) referenced by the web page are requested. A cookie is defined by a name and a value pair that can be added to `httpRequestCookies()` collection
    Returns:
      the collection of custom HTTP cookies to be sent by converter to the web server when the web page to convert and the resources (image, css, etc) referenced by the web page are requested

  - ### xpSupplementalLanguages

    public boolean xpSupplementalLanguages()
    Gets the flag in converter indicating if the supplemental languages (complex script, right-to-left, East Asian) support was enabled in Windows XP Regional and Language Options
    Returns:
      the flag in converter indicating if the supplemental languages support was enabled in Windows XP

  - ### setXPSupplementalLanguages

    public void setXPSupplementalLanguages(boolean enabled)
    Sets the flag in converter indicating if the supplemental languages (complex script, right-to-left, East Asian) support was enabled in Windows XP Regional and Language Options. The default value is false
    Parameters:
      `enabled` - the flag value to set

  - ### avoidImageBreak

    public boolean avoidImageBreak()
    Gets the flag indicating if converter will try to avoid cutting off the images between PDF pages
    Returns:
      the flag value

  - ### setAvoidImageBreak

    public void setAvoidImageBreak(boolean avoidImageBreak)
    Sets the flag indicating if the converter will try to avoid cutting off the images between PDF pages
    Parameters:
      `avoidImageBreak` - the flag value

  - ### avoidHtmlElementsBreakSelectors

    public String[] avoidHtmlElementsBreakSelectors()
    Gets the CSS selectors of the HTML elements to not be broken between PDF pages if possible.
    Returns:
      the CSS selectors

  - ### setAvoidHtmlElementsBreakSelectors

    public void setAvoidHtmlElementsBreakSelectors(String[] selectors)
    Sets the CSS selectors of the HTML elements to not be broken between PDF pages if possible.
    Parameters:
      `selectors` - the CSS selectors to set

  - ### pageBreakBeforeHtmlElementsSelectors

    public String[] pageBreakBeforeHtmlElementsSelectors()
    Gets the CSS selectors of the HTML elements before which to force a page break in PDF document
    Returns:
      the CSS selectors

  - ### setPageBreakBeforeHtmlElementsSelectors

    public void setPageBreakBeforeHtmlElementsSelectors(String[] selectors)
    Sets the CSS selectors of the HTML elements before which to force a page break in PDF document
    Parameters:
      `selectors` - the CSS selectors to set

  - ### pageBreakAfterHtmlElementsSelectors

    public String[] pageBreakAfterHtmlElementsSelectors()
    Gets the CSS selectors of the HTML elements after which to force a page break in PDF document
    Returns:
      the CSS selectors

  - ### setPageBreakAfterHtmlElementsSelectors

    public void setPageBreakAfterHtmlElementsSelectors(String[] selectors)
    Sets the CSS selectors of the HTML elements after which to force a page break in PDF document
    Parameters:
      `selectors` - the CSS selectors to set

  - ### proxyOptions

    public ProxyOptions proxyOptions()
    Gets a reference to an object encapsulating the proxy options used by converter to access the HTML document to convert
    Returns:
      a reference to an object encapsulating the proxy options used by converter to access the HTML document to convert

  - ### authenticationOptions

    public AuthenticationOptions authenticationOptions()
    This property can be set with an username and a password in order to authenticate to the web server before accessing the URL to be converted They can be used for example to resolve the IIS Integrated Windows Authentication or other types of IIS authentication
    Returns:
      the object encapsulating the authentication options

  - ### impersonationOptions

    public ImpersonationOptions impersonationOptions()
    The impersonation options applied during navigation
    Returns:
      the object encapsulating the impersonation options

  - ### pdfBookmarkOptions

    public PdfBookmarkOptions pdfBookmarkOptions()
    Gets a reference to the object controlling the bookmarks creation for the rendered PDF document. In order to enable creation of bookmarks you have to set the `PdfBookmarkOptions.htmlElementSelectors()` property of `PdfBookmarkOptions` class with the CSS selectors of the HTML elements you want to bookmark
    Returns:
      a reference to the object controlling the bookmarks creation

  - ### tableOfContentsEnabled

    public boolean tableOfContentsEnabled()
    Gets the flag indicating if this HTML to Image element can contribute to the PDF document table of contents
    Returns:
      flag indicating if this HTML to Image element can contribute to the PDF document table of contents

  - ### setTableOfContentsEnabled

    public void setTableOfContentsEnabled(boolean enabled)
    Sets flag indicating if this HTML to Image element can contribute to the PDF document table of contents. The default value is true
    Parameters:
      `enabled` - the flag value to set

  - ### htmlElementsMappingOptions

    public HtmlElementsMappingOptions htmlElementsMappingOptions()
    Gets a reference to the object that can be used to obtain the position in PDF of the HTML elements rendered by converter. In order to retrieve the position in PDF for a list of HTML elements, the `HtmlElementsMappingOptions.htmlElementSelectors()` property of `HtmlElementsMappingOptions` class must be set with an array of strings containing the CSS selectors of the HTML elements you want to map. The positions of the HTML elements in the generated PDF document will be returned in the `HtmlElementsMappingOptions.htmlElementsMappingResult()` object after the element was added to the page
    Returns:
      a reference to the object that can be used to obtain the position in PDF of the HTML elements rendered by converter

  - ### renderedPagesRectangles

    public PdfRectangle[] renderedPagesRectangles()
    Gets the bounds of the rendered rectangle on each PDF page. This property is assigned after the element has been added to a PDF page
    Returns:
      the bounds of the rendered rectangle on each PDF page

  - ### htmlDocumentInfo

    public HtmlDocumentInfo htmlDocumentInfo()
    Gets an object populated after conversion with the title, keywords, and description of the converted HTML document
    Returns:
      an object populated after conversion with the title, keywords, and description of the converted HTML document

  - ### showHeaderInOddPages

    public boolean showHeaderInOddPages()
    Gets the flag indicating if the header is displayed in the odd pages of the PDF document where this element is rendered
    Returns:
      the flag value

  - ### setShowHeaderInOddPages

    public void setShowHeaderInOddPages(boolean showHeaderInOddPages)
    Sets the flag indicating if the header is displayed in the odd pages of the PDF document where this element is rendered
    Parameters:
      `showHeaderInOddPages` - the flag value to set

  - ### showHeaderInEvenPages

    public boolean showHeaderInEvenPages()
    Gets the flag indicating if the header is displayed in the even pages of the PDF document where this element is rendered
    Returns:
      the flag value

  - ### setShowHeaderInEvenPages

    public void setShowHeaderInEvenPages(boolean showHeaderInEvenPages)
    Sets flag indicating if the header is displayed in the even pages of the PDF document where this element is rendered
    Parameters:
      `showHeaderInEvenPages` - the flag value to set

  - ### showFooterInOddPages

    public boolean showFooterInOddPages()
    Gets the flag indicating if the footer is displayed in the odd pages of the PDF document where this element is rendered
    Returns:
      the flag value

  - ### setShowFooterInOddPages

    public void setShowFooterInOddPages(boolean showFooterInOddPages)
    Sets the flag indicating if the footer is displayed in the odd pages of the PDF document where this element is rendered
    Parameters:
      `showFooterInOddPages` - the flag value to set

  - ### showFooterInEvenPages

    public boolean showFooterInEvenPages()
    Gets the flag indicating if the footer is displayed in the even pages of the PDF document where this element is rendered
    Returns:
      the flag value

  - ### setShowFooterInEvenPages

    public void setShowFooterInEvenPages(boolean showFooterInEvenPages)
    Sets flag indicating if the footer is displayed in the even pages of the PDF document where this element is rendered
    Parameters:
      `showFooterInEvenPages` - the flag value to set